const keyword_NS = "http://home.netscape.com/NC-rdf#ShortcutURL";
const icon_NS = "http://home.netscape.com/NC-rdf#Icon";
const toolbar_NS = "http://www.mozilla.org/products/firefox/#BookmarksToolbarFolder";
const XBEL_PUBLIC_ID = "+//IDN python.org//DTD XML Bookmark Exchange Language 1.0//EN//XML";

var LOSE_BOOKMARKS_TOOLBAR = "losetoolbarfolder";
var NEW_FOLDER_ALERT = "A new bookmark folder was generated.\nMake sure the remote file up-to-date.\nOtherwise, the synchronizer will create the same folder again.";
BookmarksWrapper.bookmarkCount=0;
// constructor
function BookmarksWrapper() {
	this.serializer = null;
	this.RDFService = null;
	this.DataSource = null;
	this.Container = null;
	this.BookmarksToolbarFolder = null;
	this.newfolderalert = false;
	this.icons = null;
	this.urlArc = null;
	 
	this.ConsoleService = Cc["@mozilla.org/consoleservice;1"]
			.getService(Ci.nsIConsoleService);

	this.serializer = new XMLSerializer();
	this.RDFService = Cc["@mozilla.org/rdf/rdf-service;1"]
			.getService(Ci.nsIRDFService);
	this.Container = Cc["@mozilla.org/rdf/container;1"]
			.getService(Ci.nsIRDFContainer);
	this.BookmarkService = Cc["@mozilla.org/browser/nav-bookmarks-service;1"]
			.getService(Ci.nsINavBookmarksService);
	this.HistoryService = Cc["@mozilla.org/browser/nav-history-service;1"]
			.getService(Ci.nsINavHistoryService);
	this.TagService = Cc["@mozilla.org/browser/tagging-service;1"]
			.getService(Ci.nsITaggingService);
	this.IoService = Cc["@mozilla.org/network/io-service;1"]
			.getService(Ci.nsIIOService);
	this.AnnotationsService = Cc["@mozilla.org/browser/annotation-service;1"]
			.getService(Ci.nsIAnnotationService);

	this.RDFCUtils = Cc['@mozilla.org/rdf/container-utils;1']
			.getService(Ci.nsIRDFContainerUtils);
	this.icons = [];

	this.urlArc = this.RDFService
			.GetResource("http://home.netscape.com/NC-rdf#URL");
	this.nameArc = this.RDFService
			.GetResource("http://home.netscape.com/NC-rdf#Name");
	this.descArc = this.RDFService
			.GetResource("http://home.netscape.com/NC-rdf#Description");
	this.dateArc = this.RDFService
			.GetResource("http://home.netscape.com/NC-rdf#BookmarkAddDate");

	this.DEFAULT_FOLDER_NAME = "del.icio.us";
}

BookmarksWrapper.prototype.debug = function() {
	log("BookmarksWrapper: ", arguments);
}
BookmarksWrapper.prototype.anothertalker = function(title,uri,tags) {
	
				alert("Look jere:"+tags
						+ "-"
						+  uri
						+ "-"
						+ ( title == ""
								?  uri
								: title));
	//alert(a1+"letzstalk2"+a2);
}
BookmarksWrapper.prototype.exportBookmarks = function(exportFolderId,useFolders,onlyCount,customFunc,useFolderNamesAsTags,exportAsPrivate) 
{
	//this.processBMFolder(this.BookmarkService.toolbarFolder,customFunc);
//	this.BookmarkService.toolbarFolder
//	this.BookmarkService.bookmarksMenuFolder	
//	this.BookmarkService.unfiledBookmarksFolder
	if (exportFolderId<-1)
	{
		switch (exportFolderId)
		{
		case -1:
			exportFolderId=PlacesUIUtils.allBookmarksFolderId;
			break;
		case -2:
			exportFolderId= this.BookmarkService.bookmarksMenuFolder;	
			break;
		case -3:
			exportFolderId= this.BookmarkService.toolbarFolder;

			break;
		case -4:
			exportFolderId=this.BookmarkService.unfiledBookmarksFolder;
			break;

		}
		BookmarksWrapper.bookmarkCount=this.processBMFolder(exportFolderId,useFolders,null,1)-1;
		if (!onlyCount)
		{
			this.processBMFolder(exportFolderId,useFolders,customFunc,1,useFolderNamesAsTags,exportAsPrivate);
		}

	}
	else
	{
		if (exportFolderId==-1)
		{


			var count=0;
			BookmarksWrapper.bookmarkCount=this.processBMFolder(this.BookmarkService.unfiledBookmarksFolder,useFolders,null,1)-1;

			BookmarksWrapper.bookmarkCount+=this.processBMFolder(this.BookmarkService.bookmarksMenuFolder,useFolders,null,1)-1;

			BookmarksWrapper.bookmarkCount+=this.processBMFolder(this.BookmarkService.toolbarFolder,useFolders,null,1)-1;
			if (!onlyCount)
			{
				count=this.processBMFolder(this.BookmarkService.unfiledBookmarksFolder,useFolders,customFunc,1,useFolderNamesAsTags,exportAsPrivate);
				//    alert(parseInt(count));
				count=this.processBMFolder(this.BookmarkService.bookmarksMenuFolder,useFolders,customFunc,count,useFolderNamesAsTags,exportAsPrivate);
				// alert(parseInt(count));
				count= this.processBMFolder(this.BookmarkService.toolbarFolder,useFolders,customFunc,count,useFolderNamesAsTags,exportAsPrivate);
				//     alert(parseInt(count));
			}


		}
		else 
		{
			BookmarksWrapper.bookmarkCount=this.processBMFolder(exportFolderId,useFolders,null,1)-1;	
			count=BookmarksWrapper.bookmarkCount=this.processBMFolder(exportFolderId,useFolders,customFunc,1,useFolderNamesAsTags,exportAsPrivate);


		}
	}
	// BookmarksWrapper.bookmarkCount=this.processBMFolder(exportFolderId,null,1);	
//	BookmarksWrapper.bookmarkCount=this.processBMFolder(this.BookmarkService.unfiledBookmarksFolder,null,1);
//	BookmarksWrapper.bookmarkCount--;
//	this.processBMFolder(exportFolderId,customFunc,1);
//	this.processBMFolder(this.BookmarkService.unfiledBookmarksFolder,customFunc);


}
/*
 * Traverses the bookmarks beginning with a specific folder and then calls a
 * custom function for every bookmark.
 */
BookmarksWrapper.prototype.processBMFolder = function(aFolder, useFolders,customFunc,bCount,useFolderNamesAsTags,exportAsPrivate) 
	{
	var myfunc = customFunc;
	var options = this.HistoryService.getNewQueryOptions();
	var query = this.HistoryService.getNewQuery();
	var folder = aFolder;
	query.setFolders([folder], 1);
    options.excludeQueries=false;
    options.expandQueries=true;
	//options.excludeQueries = true;
	var result = this.HistoryService.executeQuery(query, options);
	var rootNode = result.root;
	
    var myCount=bCount;


	rootNode.containerOpen = true;

	for (var i = 0; i < rootNode.childCount; i++) {
		var actElement = rootNode.getChild(i);
		switch (actElement.type) {
			case actElement.RESULT_TYPE_URI :
				var myURI = this.IoService.newURI(actElement.uri, null, null);
				var count = {};
				var tt = this.TagService.getTagsForURI(myURI, count);
				tags = '';
          for(var j in tt)
          {
            tags += tt[j]+" ";
          }
          if(useFolderNamesAsTags)
        {
          ftags = bmWrapper.getBMTitle(aFolder);
          var arr = ftags.split(' ');
          ftags = '';
          for(var j in arr)
          {
          	if (j>0)
          	tags += "_";
          	
            tags += arr[j];
          }
        }
            //    tt=tt.replace(","," ");
          if (myfunc!=null)
				myfunc(actElement.uri,actElement.title,tags,"",myCount,exportAsPrivate);//"na -","- so");
myCount++;
				break;
			case actElement.RESULT_TYPE_FOLDER :
				
				if (!(this.AnnotationsService.itemHasAnnotation(
						actElement.itemId, "livemark/feedURI"))) 
				{
					if (useFolders)
					{
				       myCount=	this.processBMFolder(actElement.itemId, useFolders,myfunc,myCount,useFolderNamesAsTags,exportAsPrivate);
					}
				}

				break;
		}

	}
	rootNode.containerOpen = false;
return myCount;
}
function doQuery(query){
  var Cc = Components.classes;
  var Ci = Components.interfaces;
  var hs = Cc["@mozilla.org/browser/nav-history-service;1"].
           getService(Ci.nsINavHistoryService);
 
  // convert URI to queries and options
  var options = { };
  var queries = { };
  var size = { };
  hs.queryStringToQueries(query, queries, size, options);
 
  // reasonableness
  if (!options.value.maxResults || options.value.maxResults > 10)
    options.value.maxResults = 10;
 
  // execute query
  var result = hs.executeQueries(queries.value, size.value, options.value);
  return result;
  //var root = result.root;
 // root.containerOpen = true;
 // return root;
};
/*
 * Gets all available/releveant bookmarks.
 */
BookmarksWrapper.prototype.getBookmarks = function() {
	try {
		//return doQuery("place:folder=PlacesUIUtils.allBookmarksFolderId&queryType=1");
		//&folder=BOOKMARKS_MENU&folder=UNFILED_BOOKMARKS&folder=TOOLBAR&queryType=1&excludeItems=true&expandQueries=true");//&excludeQueries=1");//&sort=12&excludeItemIfParentHasAnnotation=livemark%2FfeedURI");
			//	"//&maxResults=10&excludeQueries=1");
		var options = this.HistoryService.getNewQueryOptions();
		options.excludeQueries = true;
		options.excludeItems = true;
		options.excludeItemIfParentHasAnnotation="livemark%2FfeedURI";
		/*options.queryType = 0;
		options.sortingMode = options.SORT_BY_VISITCOUNT_DESCENDING;
		options.maxResults = 10;*/ 

		var query = this.HistoryService.getNewQuery();
		//query.setFolders([this.BookmarkService.toolbarFolder], 1);
		query.setFolders([PlacesUIUtils.allBookmarksFolderId], 1);
		// hs.queryStringToQueries(aPlaceURI, queries, size, options);
 
		 
		//query.setFolders([this.BookmarkService.placesRoot],1);
		//[this.BookmarkService.toolbarFolder],[this.BookmarkService.bookmarksMenuFolder],[this.BookmarkService.unfiledBookmarksFolder], 3);
			
//this.BookmarkService.unfiledBookmarksFolder

		return this.HistoryService.executeQuery(query, options);
	} catch (ex) {
		this.debug("Error getting history:" + ex);
	}
}
BookmarksWrapper.prototype.getBookmarks2 = function() {
	try {

		// no query parameters will get all history
		var options = this.HistoryService.getNewQueryOptions();
		options.queryType = 0;
		options.sortingMode = options.SORT_BY_VISITCOUNT_DESCENDING;
		options.maxResults = 10;

		var query = this.HistoryService.getNewQuery();

		// execute the query
		var result = this.HistoryService.executeQuery(query, options);
		return result;

		/*
		 * var options = this.HistoryService.getNewQueryOptions();
		 * options.excludeQueries = true; options.queryType=0;
		 * options.sortingMode = options.SORT_BY_VISITCOUNT_DESCENDING;
		 * options.maxResults=10;
		 * 
		 * var query = this.HistoryService.getNewQuery();
		 * query.setFolders([this.BookmarkService.toolbarFolder], 1);
		 * 
		 * return this.HistoryService.executeQuery(query, options);
		 */
	} catch (ex) {
		this.debug("Error getting history:" + ex);
	}
}

/*
 * Searches through all bookmarks in the toolbarFolder containing a matching
 * string description of the passed in term.
 */
BookmarksWrapper.prototype.findBookmarksWith = function(term) {
	try {
		var options = this.HistoryService.getNewQueryOptions();
		options.excludeQueries = true;

		var query = this.HistoryService.getNewQuery();
		query.setFolders([this.BookmarkService.toolbarFolder], 1);
		query.searchTerms = term;

		return this.HistoryService.executeQuery(query, options);
	} catch (ex) {
		this.debug("Error executing findBookmarksWith query:" + ex);
	}
}

// {{{ function rebuild
BookmarksWrapper.prototype.rebuild = function(folderID, str) {
	this.init();
	try {
		var target = this.RDFService.GetResource(folderID);
		if (!this.RDFCUtils.IsContainer(this.DataSource, target))
			return false;
		if (!str)
			return "noxbel";
		str = this.convertToUnicode(str);
		var parser = new DOMParser();
		var dom = parser.parseFromString(str, "text/xml");
		if (!this.isXBELDocument(dom))
			return "noxbel";
		var toolbarid = this.getBookmarksToolbarFolder(dom);
		if (!toolbarid && this.isToolbarFolderIn(folderID)
				&& !confirm(LOSE_BOOKMARKS_TOOLBAR))
			return "usercancel";
	} catch (e) {
		alert(e);
		return "error";
	}
	this.DataSource.beginUpdateBatch();
	this.killBookmarks();
	try {
		if (IsMerging())
			this.mergeFolderContents(dom.documentElement, target, toolbarid);
		else {
			this.deleteFolderContents(target);
			this.buildFolderContents(dom.documentElement, target, toolbarid);
		}
		this.setBookmarksToolbarFolder();
		this.DataSource.transactionManager.clear();
	} catch (e) {
		this.reliveBookmarks();
		this.DataSource.endUpdateBatch();
		if (e)
			alert(e);
		return "error";
	}
	this.reliveBookmarks();
	this.DataSource.endUpdateBatch();

	while (this.icons.length > 0) {
		var icon = this.icons.shift();
		this.DataSource.updateBookmarkIcon(icon[0], icon[1]);
	}
	return null;
}
// }}}

// {{{ function mergeFolderContents
BookmarksWrapper.prototype.mergeFolderContents = function(node, target,
		toolbarid) {
	var foldersets = [[node, target]];
	var folderset = null;

	while (foldersets.length > 0) {
		folderset = foldersets.shift();
		var childNodes = folderset[0].childNodes;
		var resource = folderset[1];
		var title = "";
		var href = "";
		var desc = "";
		var keyword = "";
		var id = "";
		var icon = "";

		if (this.RDFCUtils.IsContainer(this.DataSource, resource))
			this.Container.Init(this.DataSource, resource);
		else
			this.Container = this.RDFCUtils.MakeSeq(this.DataSource, resource);

		for (var i = 0; i < childNodes.length; i++) {
			var element = childNodes[i];
			if (element.nodeType == 1) {
				id = this.getProp(element, "id");
				if (!id)
					id = "urn:anonymous";
				var oldResource = this.RDFService.GetResource(id);
				var oldDataExists = (this.Container.IndexOf(oldResource) > -1)

				switch (element.localName.toUpperCase()) {
					case "BOOKMARK" :
						title = this.getTitle(element);
						href = this.getProp(element, "href");
						desc = this.getDesc(element);
						keyword = this.getMetaInfo(element, keyword_NS);
						icon = this.getMetaInfo(element, icon_NS);

						if (oldDataExists) {
							this.changeBookmark(oldResource, title, href,
									keyword, desc);
						} else {
							var bookmark = this.getBookmarkByName(title);
							if (bookmark)
								this.changeBookmark(oldResource, title, href,
										keyword, desc);
							else
								this.createBookmark(id, title, href, keyword,
										desc, resource);
						}

						if (href && icon)
							this.icons.push([href, icon]);

						break;
					case "FOLDER" :
						title = this.getTitle(element);
						desc = this.getDesc(element);
						var folder = null;
						if (oldDataExists)
							folder = oldResource;
						else {
							folder = this.getFolderByName(title);
							if (!folder) {
								// folder=this.createFolder(id,title,desc,resource);
								folder = this.DataSource
										.createFolderInContainer(title,
												resource, 0);
								this.newfolderalert = true;
							}
						}

						this.changeFolder(folder, title, desc);
						foldersets.push([element, folder]);

						if (toolbarid && id == toolbarid)
							this.BookmarksToolbarFolder = folder;
						break;
					case "SEPARATOR" :
						// if( ! oldDataExists )
						// this.createSeparator(resource);
						break;
					default :
						break;
				}
			}
		}
	}
}
// }}}

// {{{ function getBookmarkByName
BookmarksWrapper.prototype.getBookmarkByName = function(aName) {
	var elements = this.Container.GetElements();

	while (elements.hasMoreElements()) {
		var element = elements.getNext();
		element.QueryInterface(Ci.nsIRDFResource);
		if (this.DataSource.hasArcOut(element, this.urlArc)) {
			var target = this.DataSource.GetTarget(element, this.nameArc, true);
			if (target
					&& target.QueryInterface(Ci.nsIRDFLiteral).Value == aName)
				return element;
		}
	}
	return null;
}
// }}}

// {{{ function getFolderByName
BookmarksWrapper.prototype.getFolderByName = function(aName) {
	var elements = this.Container.GetElements();
	while (elements.hasMoreElements()) {
		var element = elements.getNext();
		element.QueryInterface(Ci.nsIRDFResource);
		if (this.RDFCUtils.IsContainer(this.DataSource, element)) {
			var target = this.DataSource.GetTarget(element, this.nameArc, true);
			if (target
					&& target.QueryInterface(Ci.nsIRDFLiteral).Value == aName)
				return element;
		}
	}
	return null;
}
// }}}

// {{{ function getBookmarksToolbarFolder
BookmarksWrapper.prototype.getBookmarksToolbarFolder = function(targetDocument) {
	var metadata = targetDocument.getElementsByTagName("metadata");
	for (var i = 0; i < metadata.length; i++) {
		var owner = metadata[i].getAttribute("owner");
		if (owner == toolbar_NS) {
			return this.getText(metadata[i]);
		}
	}
	return null;
}
// }}}

// {{{ function isToolbarFolderIn
BookmarksWrapper.prototype.isToolbarFolderIn = function(uri) {
	var personalArc = this.RDFService
			.GetResource("http://home.netscape.com/NC-rdf#BookmarksToolbarFolder");
	var trueVal = this.RDFService.GetLiteral("true");
	var BTF = this.DataSource.GetSource(personalArc, trueVal, true);
	if (!BTF)
		return false;
	var root = this.RDFService.GetResource(uri);

	return this.isBookmarkedResource(BTF, root);
}
// }}}

// {{{ function setBookmarksToolbar
BookmarksWrapper.prototype.setBookmarksToolbarFolder = function() {
	if (this.BookmarksToolbarFolder)
		this.DataSource.setBookmarksToolbarFolder(this.BookmarksToolbarFolder);
}
// }}}

// {{{ function isBookmarkedResource
BookmarksWrapper.prototype.isBookmarkedResource = function(uri, folderId) {
	if (!uri) {
		return false;
	}

	var rootNode;
	var isBookmarked = false;
	try {
		var options = this.HistoryService.getNewQueryOptions();
		options.excludeQueries = true;

		var query = this.HistoryService.getNewQuery();
		query.setFolders([folderId], 1);

		rootNode = this.HistoryService.executeQuery(query, options).root;
	} catch (ex) {
		error(ex);
		this.debug("Error executing findBookmarksWith query:" + ex);
		throw ex;
	}

	rootNode.containerOpen = true;
	if (rootNode.hasChildren && rootNode.childCount > 0) {
		for (var i = 0; i < rootNode.childCount; i++) {
			if (rootNode.getChild(i).uri == uri) {
				isBookmarked = true;
				break;
			}
		}
	}
	rootNode.containerOpen = false;

	return isBookmarked;
}
// }}}

// {{{ function buildFolderContents
BookmarksWrapper.prototype.buildFolderContents = function(node, target,
		toolbarid) {
	var foldersets = [[node, target]];
	var folderset = null;

	while (foldersets.length > 0) {
		folderset = foldersets.shift();
		var childNodes = folderset[0].childNodes;
		var resource = folderset[1];
		var title = "";
		var href = "";
		var desc = "";
		var keyword = "";
		var id = "";
		for (var i = 0; i < childNodes.length; i++) {
			var element = childNodes[i];
			if (element.nodeType == 1) {
				id = this.getProp(element, "id");
				switch (element.localName.toUpperCase()) {
					case "BOOKMARK" :
						title = this.getTitle(element);
						href = this.getProp(element, "href");
						desc = this.getDesc(element);
						keyword = this.getMetaInfo(element, keyword_NS);
						icon = this.getMetaInfo(element, icon_NS);
						this.DataSource.createBookmarkInContainer(title, href,
								keyword, desc, "", null, resource, 0);
						if (href && icon)
							this.icons.push([href, icon]);
						break;
					case "FOLDER" :
						title = this.getTitle(element);
						var newresource = this.DataSource
								.createFolderInContainer(title, resource, 0);
						foldersets.push([element, newresource]);
						if (toolbarid && id == toolbarid)
							this.BookmarksToolbarFolder = newresource;
						break;
					case "SEPARATOR" :
						this.createSeparator(resource);
						break;
				}
			}
		}
	}
}

BookmarksWrapper.prototype.deleteFolderContents = function(folderId) {
	this.BookmarkService.removeFolderChildren(folderId);
}
// }}}

// {{{ function getProp
BookmarksWrapper.prototype.getProp = function(element, prop) {
	if (element.hasAttribute(prop))
		return element.getAttribute(prop).replace(/\%3A/g, ":");
	else
		return "";
}
// }}}

// {{{ function getTitle
BookmarksWrapper.prototype.getTitle = function(element) {
	try {
		var tagName = element.tagName.toUpperCase();
		if (tagName != "FOLDER" && tagName != "BOOKMARK" && tagName != "XBEL")
			throw "Error : Unexpected Error\n";
		var titles = element.getElementsByTagName("title");

		if (titles.length > 0)
			return this.getText(titles[0]);
	} catch (e) {
		if (e)
			alert(e);
	}
	return "No Title";
}
// }}}

// {{{ function getDesc
BookmarksWrapper.prototype.getDesc = function(element) {
	var str = "";
	try {
		var tagName = element.tagName.toUpperCase();
		if (tagName != "FOLDER" && tagName != "BOOKMARK" && tagName != "XBEL")
			throw "Error : Unexpected Error\n";
		var descs = element.getElementsByTagName("desc");
		if (descs.length > 0)
			str = this.getText(descs[0]);
	} catch (e) {
		if (e)
			alert(e);
	}
	return str;
}
// }}}

// {{{ function getMetaInfo
BookmarksWrapper.prototype.getMetaInfo = function(aElement, aOwner) {
	try {
		var tagName = aElement.tagName.toUpperCase();
		if (tagName != "FOLDER" && tagName != "BOOKMARK" && tagName != "XBEL")
			throw "Error : Unexpected Error\n";
		var infos = aElement.getElementsByTagName("info");
		if (infos.length < 1)
			return "";
		var metadata = infos[0].getElementsByTagName("metadata");
		for (var i = 0; i < metadata.length; i++) {
			if (aOwner == this.getProp(metadata[i], "owner"))
				return this.getText(metadata[i]);
		}
	} catch (e) {
		alert(e);
	}
	return "";
}
// }}}

// {{{ function getText
BookmarksWrapper.prototype.getText = function(element) {
	var str = "";
	try {
		var textnodes = element.childNodes;
		for (var i = 0; i < textnodes.length; i++) {
			var textnode = textnodes[0];
			if (textnode.nodeType != 1)
				str += textnode.nodeValue;
		}
	} catch (e) {
		alert(e);
	}
	return str;
}
// }}}

// {{{ function changeBookmark
BookmarksWrapper.prototype.changeBookmark = function(bookmark, name, url,
		keyword, desc) {
	this.Unassert(this.DataSource, bookmark);

	var keywordArc = this.RDFService
			.GetResource("http://home.netscape.com/NC-rdf#ShortcutURL");
	var dateArc = this.RDFService
			.GetResource("http://home.netscape.com/NC-rdf#BookmarkAddDate");

	var nameTarget = this.RDFService.GetLiteral(name);
	var urlTarget = this.RDFService.GetLiteral(url);
	var keywordTarget = this.RDFService.GetLiteral(keyword);
	var descTarget = this.RDFService.GetLiteral(desc);
	var dateTarget = this.RDFService.GetDateLiteral(this.getDate());

	this.DataSource.Assert(bookmark, this.nameArc, nameTarget, true);
	this.DataSource.Assert(bookmark, this.urlArc, urlTarget, true);
	this.DataSource.Assert(bookmark, keywordArc, keywordTarget, true);
	this.DataSource.Assert(bookmark, this.descArc, descTarget, true);
	this.DataSource.Assert(bookmark, dateArc, dateTarget, true);
}
// }}}

// {{{ function changeFolder
BookmarksWrapper.prototype.changeFolder = function(folder, name, desc) {
	this.resetFolder(folder);

	var nameTarget = this.RDFService.GetLiteral(name);
	var descTarget = this.RDFService.GetLiteral(desc);

	this.DataSource.Assert(folder, this.nameArc, nameTarget, true);
	this.DataSource.Assert(folder, this.descArc, descTarget, true);
}
// }}}

// {{{ function resetFolder
BookmarksWrapper.prototype.resetFolder = function(node) {
	var props = this.DataSource.ArcLabelsOut(node);
	while (props.hasMoreElements()) {
		var prop = props.getNext();
		prop.QueryInterface(Ci.nsIRDFResource);
		if (prop.Value.match(/Name|Description/)) {
			var target = this.DataSource.GetTarget(node, prop, true);
			this.DataSource.Unassert(node, prop, target);
		}
	}
}
// }}}

// {{{ function createBookmark
BookmarksWrapper.prototype.createBookmark = function(parentId, uri, index,
		title, tags) {
			//alert(parseInt(tags.length));
	if ((tags && tags.length > 0)) {
		if (tags[0]!="")
		this.TagService.tagURI(uri, tags);

	}

	return this.BookmarkService.insertBookmark(parentId, uri, index, title);
}
// }}}

// {{{ function createFolder
BookmarksWrapper.prototype.createFolder = function(name, parentId, index) {
	parentId = !parentId ? this.BookmarkService.toolbarFolder : parentId;
	return this.BookmarkService.createFolder(parentId, name, index);
}
// }}}

// {{{ function createSeparator
BookmarksWrapper.prototype.createSeparator = function(parent) {
	var sep = this.DataSource.createSeparator();

	if (!parent)
		parent = this.RDFService.GetResource("NC:BookmarksRoot");
	// Init Container with Parent Folder
	if (!parent.EqualsString(this.Container.Resource.Value))
		this.Container.Init(this.DataSource, parent);
	this.Container.AppendElement(sep);
}
// }}}

// {{{ function getDate
BookmarksWrapper.prototype.getDate = function() {
	var date = ((new Date()).getTime()) * 1000;
	date = parseInt(date).toString();
	return date;
}
// }}}

// RDF wrapping functions
// {{{ function Assert
BookmarksWrapper.prototype.Assert = function(ds, resource, arc, target) {
	var oldtarget = ds.GetTarget(resource, arc, true);
	if (oldtarget)
		ds.Change(resource, arc, oldtarget, target);
	else
		ds.Assert(resource, arc, target, true);
}
// }}}

// {{{ function Unassert
BookmarksWrapper.prototype.Unassert = function(ds, node) {
	var props = ds.ArcLabelsOut(node);
	while (props.hasMoreElements()) {
		var prop = props.getNext();
		var target = ds.GetTarget(node, prop, true);
		ds.Unassert(node, prop, target);
	}
}
// }}}

// {{{ function killBookmarks
BookmarksWrapper.prototype.killBookmarks = function() {
	var nsIWindowMediator = Cc['@mozilla.org/appshell/window-mediator;1']
			.getService(Ci.nsIWindowMediator);
	var browserWindows = nsIWindowMediator.getZOrderDOMWindowEnumerator(
			'navigator:browser', true);
	while (browserWindows.hasMoreElements()) {
		try {
			var browserWindow = browserWindows.getNext();
			browserWindow.QueryInterface(Ci.nsIDOMWindowInternal);
			browserWindow.bookmarksftpService.unregObserver();
		} catch (e) {
			alert(e)
		}
	}
}
// }}}

// {{{ function reliveBookmarks
BookmarksWrapper.prototype.reliveBookmarks = function() {
	var nsIWindowMediator = Cc['@mozilla.org/appshell/window-mediator;1']
			.getService(Ci.nsIWindowMediator);
	var browserWindows = nsIWindowMediator.getZOrderDOMWindowEnumerator(
			'navigator:browser', true);
	while (browserWindows.hasMoreElements()) {
		try {
			var browserWindow = browserWindows.getNext();
			browserWindow.QueryInterface(Ci.nsIDOMWindowInternal);
			browserWindow.bookmarksftpService.regObserver();
		} catch (e) {
			alert(e)
		}
	}
}
// }}}

// {{{ function convertToUnicode
BookmarksWrapper.prototype.convertToUnicode = function(str) {
	var charset = "UTF-8";

	try {
		var unicodeConverter = Cc["@mozilla.org/intl/scriptableunicodeconverter"]
				.createInstance(Ci.nsIScriptableUnicodeConverter);
		if (str.match(/encoding=\"(.+)\"/m))
			charset = RegExp.$1;
		unicodeConverter.charset = charset;
		str = unicodeConverter.ConvertToUnicode(str);
		if (charset != "UTF\-16")
			str = str.replace(charset, "UTF-16");
	} catch (e) {
		alert(e);
	}
	return str;
}

BookmarksWrapper.prototype.hasChildFolder = function(folderId, childName) {
	return this.BookmarkService.getChildFolder(folderId, childName) > 0;
}

BookmarksWrapper.prototype.getChildFolder = function(folderId, childName) {
	return this.BookmarkService.getChildFolder(folderId, childName);
}

BookmarksWrapper.prototype.getBookmarksFolder = function() {
	var folder;

	var rootNode = this.findBookmarksWith(this.DEFAULT_FOLDER_NAME).root;
	rootNode.containerOpen = true;
	if (rootNode.hasChildren && rootNode.childCount > 0) {
		folder = rootNode.getChild(0).itemId;
	}
	rootNode.containerOpen = false;

	return folder;
}

// {{{ function getLiteral
BookmarksWrapper.prototype.getLiteral = function(resource, arc) {
	var target = this.DataSource.GetTarget(resource, arc, true);
	if (target)
		return target.QueryInterface(Ci.nsIRDFLiteral).Value;
	else
		return "";
}
// }}}

// {{{ function getBMTitle
BookmarksWrapper.prototype.getBMTitle = function(id) {
	return this.BookmarkService.getItemTitle(id);
}
// }}}

// {{{ function getBMURL
BookmarksWrapper.prototype.getBMURL = function(resource) {
	return this.getLiteral(resource, this.urlArc);
}
// }}}

// {{{ function getBMDescription
BookmarksWrapper.prototype.getBMDescription = function(resource) {
	return this.getLiteral(resource, this.descArc);
}
// }}}

// {{{ function getBMDate
BookmarksWrapper.prototype.getBMDate = function(resource) {
	return this.getLiteral(resource, this.dateArc);
}
// }}}

// {{{ function sortFolder
/*
 * credit to Torisugari's sortBookmarks extension for this function resourceID:
 * rdf resource id string caseSensitive: bool folderFirst: bool recursive: bool
 * separatorGroup: bool exculdeToolbar: bool sortBy: string bookmark property
 * name
 */
	BookmarksWrapper.prototype.sortFolder = function(folderId, caseSensitive,
			folderFirst, recursive, separatorGroup, exculdeToolbar, sortBy) {
	var RDFService = Cc["@mozilla.org/rdf/rdf-service;1"]
	                    .getService(Ci.nsIRDFService);
	var Container = Cc["@mozilla.org/rdf/container;1"]
	                   .getService(Ci.nsIRDFContainer);
	var RDFCUtils = Cc['@mozilla.org/rdf/container-utils;1']
	                   .getService(Ci.nsIRDFContainerUtils);

	var DataSource = RDFService.GetDataSource("rdf:bookmarks");
	DataSource.QueryInterface(Ci.nsIBookmarksService);

	var root = RDFService.GetResource(resourceID);
	if (!RDFCUtils.IsContainer(DataSource, root))
		return;

	if (!sortBy)
		sortBy = Name;

	var rdfType;
	var isReverse = false;
	switch (sortBy) {
	case "Name" :
	case "Icon" :
	case "URL" :
	case "Description" :
		rdfType = Ci.nsIRDFLiteral;
		break;
	case "LastVisitDate" :
	case "LastModifiedDate" :
		rdfType = Ci.nsIRDFDate;
		isReverse = true;
		break;
	default :
		rdfType = Ci.nsIRDFLiteral;
	break;
	};

	var arc;
	switch (sortBy) {
	case "Name" :
	case "Icon" :
	case "URL" :
	case "Description" :
		arc = RDFService.GetResource("http://home.netscape.com/NC-rdf#"
				+ sortBy);
		break;
	case "LastVisitDate" :
	case "LastModifiedDate" :
		arc = RDFService.GetResource("http://home.netscape.com/WEB-rdf#"
				+ sortBy);
		break;
	default :
		arc = RDFService.GetResource("http://home.netscape.com/NC-rdf#"
				+ sortBy);
	break;
	};

	var typeArc = RDFService
	.GetResource("http://www.w3.org/1999/02/22-rdf-syntax-ns#type");
	var sepVal = RDFService
	.GetResource("http://home.netscape.com/NC-rdf#BookmarkSeparator");

	var TBFURI = null;
	if (exculdeToolbar) {
		var tbfArc = RDFService
		.GetResource("http://home.netscape.com/NC-rdf#BookmarksToolbarFolder");
		var trueVal = RDFService.GetLiteral("true");
		var TBF = DataSource.GetSource(tbfArc, trueVal, true);
		if (TBF)
			TBFURI = TBF.QueryInterface(Ci.nsIRDFResource).Value;
		if (resourceID == TBFURI)
			return;
	}

	var sortfolders = [root];

	DataSource.beginUpdateBatch();

	while (sortfolders.length > 0) {
		var sortfolder = sortfolders.shift();
		Container.Init(DataSource, sortfolder);
		var elements = Container.GetElements();
		var folders = [];
		var bookmarks = [];
		var sortedarray = [];
		while (elements.hasMoreElements()) {
			var temp = {
					uri : "",
					name : "",
					toString : function() {
				return this.name;
			}
			};
			var element = elements.getNext();
			element.QueryInterface(Ci.nsIRDFResource);
			temp.uri = element.Value;

			try {
				var target = DataSource.GetTarget(element, arc, true);
				if (target)
					temp.name = target.QueryInterface(rdfType).Value.toString();
				if (!caseSensitive)
					temp.name = temp.name.toUpperCase();
			} catch (e) {
			}

			Container.RemoveElement(element, false);
			if (separatorGroup
					&& DataSource.HasAssertion(element, typeArc, sepVal, true)) {
				folders.sort();
				bookmarks.sort();
				sortedarray = sortedarray.concat(folders);
				sortedarray = sortedarray.concat(bookmarks);
				sortedarray.push(temp);// this sep
				folders = [];
				bookmarks = [];
			} else if (RDFCUtils.IsContainer(DataSource, element)) {
				if (recursive && TBFURI != element.Value)
					sortfolders.push(element);
				if (folderFirst)
					folders.push(temp);
				else
					bookmarks.push(temp);
			} else
				bookmarks.push(temp);
		}

		folders.sort();
		bookmarks.sort();
		if (isReverse)
			bookmarks.reverse();
		sortedarray = sortedarray.concat(folders);
		sortedarray = sortedarray.concat(bookmarks);

		for (var i in sortedarray)
			Container.AppendElement(RDFService.GetResource(sortedarray[i].uri));
	}

	try {
		DataSource.endUpdateBatch();
		DataSource.transactionManager.clear();
	} catch (ex) {
	}
}
// }}}
